Subject: Re: [PATCH] Set cpu explicitly in kernel compiles

From: Kumar Gala <[email-masked]>
Date: Thu, 5 May 2005 11:22:38 -0500

On May 5, 2005, at 10:27 AM, Tom Rini wrote:

> On Thu, May 05, 2005 at 10:12:42AM -0500, Kumar Gala wrote:
>  >
> > On May 5, 2005, at 9:23 AM, Tom Rini wrote:
>  >
> > >On Thu, May 05, 2005 at 09:00:50AM -0500, Kumar Gala wrote:
>  > > >
>  > >> On May 5, 2005, at 7:24 AM, Dan Malek wrote:
>  > > >
>  > >> >
>  > > > >
>  > > > >On May 5, 2005, at 1:22 AM, Paul Mackerras wrote:
>  > > > > > If you think we should have -mcpu=xxx on the command line 
> for
> > >4xx,
>  > > > > > 44x, 8xx, etc., then that's fine, but that is a separate 
> problem
>  > >> >from
>  > > > > > what my patch was addressing (one which my patch might make 
> it
>  > >> >easier
>  > > > > > to fix, though).
>  > > > >
>  > > > >I think that is exactly what we want, although I don't know how
> > >that is
>  > > > > separate from the patch you sent.? My original comment was the
> > >patch
>  > > > > fixes the problem for only one of the cpu cores, not all of 
> them.?
>  > >> >Which
>  > > > > then led into the subsequent suggestion of making the biarch 
> work
>  > > > > like the past compilers, and we must specific the flags for 
> POWER4
>  > > > > instead of the other way around.? Without explicit -mcpu 
> flags,
> > >the
>  > > > > existing compiler behavior is just fine .....? but, I guess 
> I'd be
>  > > > >standing
>  > > > > in the way of progress to want this :-)
>  > > >
>  > >> I agree with Dan here.? I think we should go ahead and extend the
> > >patch
>  > >> to set -mcpu and -mtune flags for the list of processors we have 
> in
>  > >> "Processor Type".? If I'm building a kernel for e500 or 4xx I 
> might
> > >as
>  > >> well get a kernel that is tuned a bit more for the subarch.?
>  > >
>  > > This is fine.
> > >
>  > >> Additionally, there should be some expert override ability, so 
> if I
>  > >> really want to do -mcpu=7455 -mtune=7455 I can.
>  > >
>  > >Gack, no!? It's quite a pain to go from CONFIG_FOO="string" into
> > >useable
>  > > Makefile bits that the one we did have back in 2.4 is gone.? That 
> also
>  > > implies gcc finally knows something about these cores that might 
> be
>  > > useful, which I don't think is the case, nor is it likely to be.? 
> But
> > >if
>  > > we did want it, we'd probably go the route x86 has.
>  >
> > I'm not saying it has to be done via a CONFIG option, all I'm saying 
> is
> > if I want to explicitly use GCC then I would hope we could somehow
> > disable it being override.
>
> If you're not doing it via CONFIG, that leaves manual (which is always
>  an option) or seeing if passing CFLAGS on the cmdline overrides 
> things,
>  or adds to them.

Thats all I really want.  Just for us to make sure if I want to do 
-mcpu=7455 -mtune=7455 I'm able to and it actually does what I told it 
to do.  I'm not sure if GCC is consistent on how it handles args that 
are duplicated.  For example what will happen with the following:

gcc -mcpu=750 -mtune=7450 -mcpu=603 -mtune=603

Is this -mcpu=750 -mtune=7450 or -mcpu=603 -mtune=603

- kumar